proc cleanup_collection { objname name1 name2 op } {
    puts "cleanup_collection is removing $objname"
    collection_manager $objname delete
}

proc setup_collection { varname given_name } {
    upvar $varname local_varname
    set local_varname [ collection_manager make $given_name ]
    puts $local_varname
    puts "calling trace add variable local_varname unset [list cleanup_collection $local_varname]"
    trace add variable local_varname unset [list cleanup_collection $local_varname]
}

proc try_it {} {
    setup_collection foo "Harry"
    puts "collection $foo has been set up and traced for deletion"
    setup_collection bar "Jane"
    puts "collection $bar has been set up and traced for deletion"
    
    puts "Get something from foo: [ collection_manager $foo name ]"
    puts "Get something from bar: [ collection_manager $bar name ]"

    puts "Try shimmer them with the well known tricks that cause shimmering..."
    lappend list_of_collections $foo
    lappend list_of_collections $bar
    set blank [encoding convertto euc-jp ""]
    string match $foo $blank
    string match $bar $blank
    
    puts "Get something from foo: [ collection_manager $foo name ]"
    puts "Get something from bar: [ collection_manager $bar name ]"

    puts "returning foo's name - that won't keep it around"
    return $foo
}

setup_collection goo "Mary"
puts "collection $goo has been set up and traced for deletion"

set t1 [ try_it ]
puts "$t1 was returned"
puts "see that $t1 is in fact gone now:"
if { [ catch {collection_manager $t1 name} msg] } {
    puts "$t1 is not a Collection."
}

# Try global scope
puts "Set up at global scope"
setup_collection foo "Barry"
puts "collection $foo has been set up and traced for deletion"
setup_collection bar "Sue"
puts "collection $bar has been set up and traced for deletion"

puts "Get something from foo: [ collection_manager $foo name ]"
puts "Get something from bar: [ collection_manager $bar name ]"

# You have to specifically unset things in global scope:
unset foo
unset bar
unset goo
